{{
Please note that this is a slightly modified version of daves.spin 74HC165 Object file.

Same usage rights apply per the MIT License contained in the attached txt file.
}}




PUB ShiftIn ( LD165, SDat165 , CLK165 , NoOfBits) :vByte | vBit
      
  dira[LD165] ~~                                                                '' Set load pin to out 
  outa[LD165] := 0                                                              '' Load pin off
  waitcnt(1000 + cnt)                                                           '' Wait for data to latch
  outa[LD165] := 1                                                              '' Load pin on
  
  dira[SDat165]  ~                                                              '' Set data pin to out

  dira[CLK165] ~~                                                               '' Set the clock Pin to out
  outa[CLK165] := 0                                                             '' Clock Pin off

  repeat NoOfBits                                                               '' Repeat for number of bits                                                                       
    vBit:=ina[SDat165]                                                          '' Read data
    vByte := (vByte << 1) + vBit                                                '' Shift Left and store next bit
    outa[CLK165] := 1                                                           '' Clock pin on
    outa[CLK165] := 0                                                           '' Clock pin off
    waitcnt(1000 + cnt)                                                         '' Wait for data to be latched, then cycle